/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class IMM extends AddressingMode {
  public static final String NAME = "IMM";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          IMM.class,
          "IMM",
          BYTE,
          new ParamDecls()
              .declareParam("i", BYTE),
          false,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IAddressingMode create(Map<String, Data> args) {
      final Location i = getArgument("i", args);
      return new IMM(i);
    }
  }

  public static final IInfo INFO = new Info();

  private final Location i;

  public IMM(Location i) {
    this.i = i;
  }

  @Override
  public String syntax() {
    return String.format("[%d]", i.load().getRawData().intValue());
  }

  @Override
  public String image() {
    return String.format("11%4b", i.load().getRawData().toBinString());
  }

  @Override
  public Location access() {
    return i;
  }
}
 