/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class sub extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         sub.class,
         "sub",
         false,
         new ParamDecls()
             .declareParam("rd", ArgumentMode.OUT, REG.INFO)
             .declareParam("rs", ArgumentMode.IN, REG.INFO)
             .declareParam("rt", ArgumentMode.IN, REG.INFO),
         false,
         false,
         true,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
      final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

      return new sub(rd, rs, rt);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "sub",
          true,
          new ParamDecls()
              .declareParam("rd", ArgumentMode.OUT, REG.INFO)
              .declareParam("rs", ArgumentMode.IN, REG.INFO)
              .declareParam("rt", ArgumentMode.IN, REG.INFO),
          true,
          true,
          true,
          false,
          false,
          0
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
      final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

      return new instruction(
        new sub(
          rd,
          rs,
          rt
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rs;
  private final IAddressingMode rt;

  public sub(IAddressingMode rd, IAddressingMode rs, IAddressingMode rt) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rs);
    assert REG.INFO.isSupported(rt);

    this.rd = rd;
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("sub %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s%s%s00000100010", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action() {
    temp.access().store(DataEngine.execute(EOperatorID.MINUS, Location.concat(rs.access(), rs.access().bitField(0x1f, 0x1f)).load(), Location.concat(rt.access(), rt.access().bitField(0x1f, 0x1f)).load()));
    if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, temp.access().bitField(0x20, 0x20).load(), temp.access().bitField(0x1f, 0x1f).load())))
    {
        COP0_R.access(0xe).store(CIA.access().load());
        exception("IntegerOverflow");
    }
    else
    {
        rd.access().store(temp.access().bitField(0x1f, 0x0).load());
    }
  }
}
