/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MFF extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MFF.class,
         "MFF",
         false,
         new ParamDecls()
             .declareParam("rt", ArgumentMode.OUT, R.INFO)
             .declareParam("fs", ArgumentMode.IN, F.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
      final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);

      return new MFF(rt, fs);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rt;
  private final IAddressingMode fs;

  public MFF(IAddressingMode rt, IAddressingMode fs) {
    assert R.INFO.isSupported(rt);
    assert F.INFO.isSupported(fs);

    this.rt = rt;
    this.fs = fs;
  }

  @Override
  public String syntax() {
    return String.format("MFF %s, %s", rt.syntax(), fs.syntax());
  }

  @Override
  public String image() {
    return String.format("01000100000%s%s00000000000", rt.image(), fs.image());
  }

  @Override
  public void action() {
    rt.access().store(fs.access().load());
  }
}
