/*
 * Copyright 2014 ISP RAS (http://www.ispras.ru)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.translator.nml.ir.expression;

/**
 * Provides constants that specify the number of operator's operands.
 * 
 * @author Andrei Tatarnikov
 */

public enum Operands {
  UNARY(1), BINARY(2), TERNARY(3);

  private final int count;

  private Operands(int count) {
    this.count = count;
  }

  /**
   * Returns operand count.
   * 
   * @return Operand count.
   */

  public int count() {
    return count;
  }
}
